OpenShot Audio Library | OpenShotAudio: juce::ChildProcess Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
juce::ChildProcess Class Reference

`#include <juce_ChildProcess.h>`

## Public Types
enum | StreamFlags { wantStdOut = 1 , wantStdErr = 2 }

## Public Member Functions
| ChildProcess ()
| ~ChildProcess ()
bool | start (const String &command, int streamFlags=wantStdOut|wantStdErr)
bool | start (const StringArray &arguments, int streamFlags=wantStdOut|wantStdErr)
bool | isRunning () const
int | readProcessOutput (void *destBuffer, int numBytesToRead)
String | readAllProcessOutput ()
bool | waitForProcessToFinish (int timeoutMs) const
uint32 | getExitCode () const
bool | kill ()

## Detailed Description

Launches and monitors a child process.

This class lets you launch an executable, and read its output. You can also use it to check whether the child process has finished.

Definition at line 35 of file juce_ChildProcess.h.

## Member Enumeration Documentation

## ◆ StreamFlags

enum juce::ChildProcess::StreamFlags

These flags are used by the start() methods.

Definition at line 50 of file juce_ChildProcess.h.

## Constructor & Destructor Documentation

## ◆ ChildProcess()

juce::ChildProcess::ChildProcess | ( |  | ) |

Creates a process object. To actually launch the process, use start().

Definition at line 26 of file juce_ChildProcess.cpp.

## ◆ ~ChildProcess()

juce::ChildProcess::~ChildProcess | ( |  | ) |

Destructor. Note that deleting this object won't terminate the child process.

Definition at line 27 of file juce_ChildProcess.cpp.

## Member Function Documentation

## ◆ getExitCode()

uint32 juce::ChildProcess::getExitCode | ( |  | ) | const

If the process has finished, this returns its exit code.

Definition at line 44 of file juce_ChildProcess.cpp.

## ◆ isRunning()

bool juce::ChildProcess::isRunning | ( |  | ) | const

Returns true if the child process is alive.

Definition at line 29 of file juce_ChildProcess.cpp.

Referenced by waitForProcessToFinish().

## ◆ kill()

bool juce::ChildProcess::kill | ( |  | ) |

Attempts to kill the child process. Returns true if it succeeded. Trying to read from the process after calling this may result in undefined behaviour.

Definition at line 39 of file juce_ChildProcess.cpp.

## ◆ readAllProcessOutput()

String juce::ChildProcess::readAllProcessOutput | ( |  | ) |

Blocks until the process has finished, and then returns its complete output as a string.

Definition at line 65 of file juce_ChildProcess.cpp.

## ◆ readProcessOutput()

int juce::ChildProcess::readProcessOutput | ( | void * | destBuffer,
|  | int | numBytesToRead
| ) |  |

Attempts to read some output from the child process. This will attempt to read up to the given number of bytes of data from the process. It returns the number of bytes that were actually read.

Definition at line 34 of file juce_ChildProcess.cpp.

Referenced by readAllProcessOutput().

## ◆ start() [1/2]

bool juce::ChildProcess::start | ( | const String & | command,
|  | int | streamFlags = `wantStdOut|wantStdErr`
| ) |  |

Attempts to launch a child process command.

The command should be the name of the executable file, followed by any arguments that are required. If the process has already been launched, this will launch it again. If a problem occurs, the method will return false. The streamFlags is a combinations of values to indicate which of the child's output streams should be read and returned by readProcessOutput().

## ◆ start() [2/2]

bool juce::ChildProcess::start | ( | const StringArray & | arguments,
|  | int | streamFlags = `wantStdOut|wantStdErr`
| ) |  |

Attempts to launch a child process command.

The first argument should be the name of the executable file, followed by any other arguments that are needed. If the process has already been launched, this will launch it again. If a problem occurs, the method will return false. The streamFlags is a combinations of values to indicate which of the child's output streams should be read and returned by readProcessOutput().

## ◆ waitForProcessToFinish()

bool juce::ChildProcess::waitForProcessToFinish | ( | int | timeoutMs | ) | const

Blocks until the process is no longer running.

Definition at line 49 of file juce_ChildProcess.cpp.

The documentation for this class was generated from the following files:

- juce_ChildProcess.h
- juce_ChildProcess.cpp